package nl.amis.rest.controller;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;

import oracle.adf.model.binding.DCBindingContainer;
import oracle.adf.model.servlet.HttpBindingContext;
import oracle.adf.share.ADFContext;
import oracle.adf.share.el.OracleExpressionEvaluatorImpl;

public class PrepareHrmServiceFilter implements Filter {
    private FilterConfig _filterConfig = null;

    public void init(FilterConfig filterConfig) throws ServletException {
        _filterConfig = filterConfig;
    }

    public void destroy() {
        _filterConfig = null;
    }

    public void doFilter(ServletRequest request, ServletResponse response,
                         FilterChain chain) throws IOException,
                                                   ServletException {
        
        // make sure the HrmService binding container is prepared when the application starts using it
        ADFContext ctx = ADFContext.getCurrent();
        OracleExpressionEvaluatorImpl elev =
            (OracleExpressionEvaluatorImpl)ctx.getExpressionEvaluator();
        HttpBindingContext data = (HttpBindingContext)elev.evaluate("${data}");
        DCBindingContainer bc =
            data.findBindingContainer("myfirstrestfulservice_HrmServicePageDef");
        
        bc.refresh(DCBindingContainer.PREPARE_MODEL);

        chain.doFilter(request, response);
    }
}
