package nl.amis.rest.resources;

import java.io.IOException;

import java.util.Collection;

import nl.amis.rest.controller.RestfulApplication;

import oracle.jbo.Row;
import oracle.jbo.RowIterator;
import oracle.jbo.uicli.binding.JUControlBinding;

import org.restlet.Context;
import org.restlet.data.MediaType;
import org.restlet.data.Request;
import org.restlet.data.Response;
import org.restlet.resource.DomRepresentation;
import org.restlet.resource.Representation;
import org.restlet.resource.Resource;
import org.restlet.resource.ResourceException;
import org.restlet.resource.Variant;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;


public class DeptResource extends Resource {

    JUControlBinding deptsBinding;
    String deptno;

    public DeptResource(Context context, Request request, Response response) {
        super(context, request, response);

        // Declare the kind of representations supported by this resource.
        getVariants().add(new Variant(MediaType.TEXT_XML));
        // Allow modifications of this resource via POST requests.
        setModifiable(true);
        deptno =
            (String)getRequest().getAttributes().get("deptno");

        deptsBinding =
                (JUControlBinding)RestfulApplication.getHrmService().findCtrlBinding("DeptView1");
    }

    /**
     * Returns a listing of all registered things.
     */
    @Override
    public Representation represent(Variant variant) throws ResourceException {
        // Generate the right representation according to its media type.
        deptsBinding.getIteratorBinding().setCurrentRowWithKeyValue(deptno);
        if (MediaType.TEXT_XML.equals(variant.getMediaType())) {
            try {
                DomRepresentation representation = RestfulApplication.createDomRepresentationForRows("departments", deptsBinding.getRowIterator(),1, 0, true, null);
                return representation;
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        return null;
    }


}

