package nl.amis.rest.resources;

import java.io.IOException;

import java.io.StringReader;

import java.util.Collection;

import java.util.List;

import java.util.Map;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import nl.amis.rest.controller.RestfulApplication;

import oracle.jbo.Row;
import oracle.jbo.RowIterator;
import oracle.jbo.uicli.binding.JUControlBinding;

import oracle.xml.parser.v2.XMLDocument;
import oracle.xml.parser.v2.XSLException;
import oracle.xml.parser.v2.XSLProcessor;
import oracle.xml.parser.v2.XSLStylesheet;

import org.restlet.Context;
import org.restlet.data.MediaType;
import org.restlet.data.Request;
import org.restlet.data.Response;
import org.restlet.resource.DomRepresentation;
import org.restlet.resource.Representation;
import org.restlet.resource.Resource;
import org.restlet.resource.ResourceException;
import org.restlet.resource.Variant;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import javax.xml.parsers.ParserConfigurationException;

import nl.amis.rest.controller.RestfulApplication;

import oracle.adfinternal.view.faces.model.binding.FacesCtrlSearchBinding;

import oracle.jbo.Row;
import oracle.jbo.RowIterator;
import oracle.jbo.uicli.binding.JUControlBinding;

import oracle.jbo.uicli.binding.JUCtrlActionBinding;

import oracle.xml.parser.v2.XMLDocument;

import oracle.xml.parser.v2.XSLException;
import oracle.xml.parser.v2.XSLProcessor;
import oracle.xml.parser.v2.XSLStylesheet;


public class DeptsResource extends Resource {

    JUControlBinding deptsBinding;
    int startRow = 0;
    int maxRows = -1;
    String queryParameter;

    public DeptsResource(Context context, Request request, Response response) {
        super(context, request, response);

        // Declare the kind of representations supported by this resource.
        getVariants().add(new Variant(MediaType.TEXT_XML));
        // Allow modifications of this resource via POST requests.
        setModifiable(true);

        deptsBinding =
                (JUControlBinding)RestfulApplication.getHrmService().findCtrlBinding("DeptView1");
        //String[] queryParam =
        //  request.getResourceRef().getQueryAsForm().getValuesArray("show");
        queryParameter =
                request.getResourceRef().getQueryAsForm().getFirstValue("show");

        String startRowParam =
            request.getResourceRef().getQueryAsForm().getFirstValue("start");
        if (startRowParam != null) {
            startRow = Integer.parseInt(startRowParam);
        } else {
            startRow = 0;
        }
        String maxRowsParam =
            request.getResourceRef().getQueryAsForm().getFirstValue("maxRows");
        if (maxRowsParam != null) {
            maxRows = Integer.parseInt(maxRowsParam);
        } else {
            maxRows = -1;
        }
    }

    /**
     * Returns a listing of all registered things.
     */
    @Override
    public Representation represent(Variant variant) throws ResourceException {
        // Generate the right representation according to its media type.
        if (queryParameter != null) {
            Object s =
                RestfulApplication.getHrmService().findNamedObject("DeptViewGlobalSearchCriteriaQuery");
            JUCtrlActionBinding search =
                (JUCtrlActionBinding)RestfulApplication.getHrmService().findCtrlBinding("applyDeptViewGlobalSearchCriteria");
            search.getParamsMap().put("searchCriteriaValue", queryParameter);
            search.invoke();

        } else {
            // unapplyAllViewCriteria
            JUCtrlActionBinding refresh =
                (JUCtrlActionBinding)RestfulApplication.getHrmService().findCtrlBinding("unapplyAllViewCriteria");
            refresh.invoke();
        }
        if (MediaType.TEXT_XML.equals(variant.getMediaType())) {
            try {
                DomRepresentation representation =
                    RestfulApplication.createDomRepresentationForRows("departments",
                                                                      deptsBinding.getRowIterator(),
                                                                      maxRows,
                                                                      startRow,
                                                                      false,
                                                                      getXsl());
                return representation;
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        return null;
    }


    private XSLStylesheet getXsl() {
        String xslString =
            "<?xml version=\"1.0\" encoding=\"windows-1252\" ?>\n" +
            "<xsl:stylesheet version=\"1.0\" xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\">\n" +
            "  <xsl:template match=\"/DeptViewRow\">\n" +
            "        <Department deptno=\"{Deptno}\">\n" +
            "          <Name><xsl:value-of  select=\"Dname\" /></Name>\n" +
            "          <Location><xsl:value-of  select=\"Loc\" /></Location>\n" +
            "        </Department>\n" +
            "  </xsl:template>" + "</xsl:stylesheet>\n";

        return RestfulApplication.getXslFromString(xslString);
    }

}

