package nl.amis.rest.resources;

import java.io.IOException;

import java.io.InputStream;

import java.io.StringReader;

import java.util.Collection;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import javax.xml.parsers.ParserConfigurationException;

import nl.amis.rest.controller.RestfulApplication;

import oracle.jbo.Row;
import oracle.jbo.RowIterator;
import oracle.jbo.uicli.binding.JUControlBinding;

import oracle.xml.parser.v2.XMLDocument;

import oracle.xml.parser.v2.XSLException;
import oracle.xml.parser.v2.XSLProcessor;
import oracle.xml.parser.v2.XSLStylesheet;


import org.restlet.Context;
import org.restlet.data.MediaType;
import org.restlet.data.Request;
import org.restlet.data.Response;
import org.restlet.resource.DomRepresentation;
import org.restlet.resource.Representation;
import org.restlet.resource.Resource;
import org.restlet.resource.ResourceException;
import org.restlet.resource.Variant;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;


public class EmpsResource extends Resource {

    JUControlBinding deptsBinding;
    String deptno;
    JUControlBinding empsBinding;
    int startRow = 0;
    int maxRows = -1;
    //You can also access the standard GET/POST parameters via

    //req.getResourceRef().getQueryAsForm().getFirstValue("SomeParameter");

    public EmpsResource(Context context, Request request, Response response) {
        super(context, request, response);

        // Declare the kind of representations supported by this resource.
        getVariants().add(new Variant(MediaType.TEXT_XML));
        // Allow modifications of this resource via POST requests.
        setModifiable(true);

        deptsBinding =
                (JUControlBinding)RestfulApplication.getHrmService().findCtrlBinding("DeptView1");
        empsBinding =
                (JUControlBinding)RestfulApplication.getHrmService().findCtrlBinding("EmpView2");

        deptno = (String)getRequest().getAttributes().get("deptno");

        String startRowParam =
            request.getResourceRef().getQueryAsForm().getFirstValue("start");
        if (startRowParam != null) {
            startRow = Integer.parseInt(startRowParam);
        } else {
            startRow = 0;
        }
        String maxRowsParam =
            request.getResourceRef().getQueryAsForm().getFirstValue("maxRows");
        if (maxRowsParam != null) {
            maxRows = Integer.parseInt(maxRowsParam);
        } else {
            maxRows = -1;
        }
    }

    /**
     * Returns a listing of all registered things.
     */
    @Override
    public Representation represent(Variant variant) throws ResourceException {
        deptsBinding.getIteratorBinding().setCurrentRowWithKeyValue(deptno);
        // Generate the right representation according to its media type.
        if (MediaType.TEXT_XML.equals(variant.getMediaType())) {            
            try {
                DomRepresentation representation =
                    RestfulApplication.createDomRepresentationForRows("employees",
                                                                      empsBinding.getRowIterator(),
                                                                      maxRows,
                                                                      startRow,
                                                                      false,
                                                                      null);
                return representation;

            } catch (IOException e) {
            }
        }
        return null;


    }
}

